﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestSqlBuilder
{
    class Program
    {
        static void Main(string[] args)
        {
            var strSql = "select * from Users t1 where ";
            var dic = new Dictionary<string, object>();
            dic["BeginAge"] = "18";//Age>=18
            dic["EndAge"] = 80;//Age<=80
            dic["LikeName"] = "玲";//Name包含'玲'
            dic["IsGirl"] = "true";//IsGirl = true 
            dic["BeginLoginTime"] = DateTime.Now.AddDays(-7);//LoginTime >= 七天前
            dic["EndLoginTime"] = DateTime.Now.ToString();//LoginTime <= 今天
            //类型映射
            SqlMapper mapper = new SqlMapper();
            mapper.SelectSingle<User>(dic, "t1");

            Console.WriteLine("格式化后的SQL语句");
            Console.WriteLine(" {0}{1}", strSql, mapper.Condition);
            Console.WriteLine("格式化后的参数");
            //看看格式化后的Dictionary
            foreach (var e in mapper.Paras)
            {
                Console.WriteLine("{0}:{1}      {2}", e.Key, e.Value, e.Value.GetType());
            }
            Console.WriteLine();
            Console.WriteLine();
            //如果是联合查询的SQL语句 模拟Js调用
            strSql = "select * from User t1 inner join Log t2 on t1.UserID=t2.UserID where ";
            var dicMulty = new Dictionary<string, Dictionary<string, object>>();
            dicMulty["t1"] = new Dictionary<string, object>();
            dicMulty["t1"]["UserID"] = "1";
            dicMulty["t1"]["Name"] = "xxx";
            dicMulty["t1"]["BeginAge"] = "18";//Age>=18
            dicMulty["t1"]["EndAge"] = 80;//Age<=80
            dicMulty["t1"]["LikeName"] = "玲";//Name包含'玲'
            dicMulty["t1"]["IsGirl"] = "true";//IsGirl = true 
            dicMulty["t1"]["BeginLoginTime"] = DateTime.Now.AddDays(-7);//LoginTime >= 七天前
            dicMulty["t1"]["EndLoginTime"] = DateTime.Now.ToString();//LoginTime <= 今天
            dicMulty["t2"] = new Dictionary<string, object>();
            dicMulty["t2"]["LogID"] = "1";
            dicMulty["t2"]["UserID"] = "1";
            dicMulty["t2"]["LikeContent"] = "坏事";//Age>=18
            dicMulty["t2"]["IsCreasy"] = "false";//Age<=80
            dicMulty["t2"]["CreateTime"] = "2013-11-05 10:52:37";//
            mapper.SelectMulity<User, Log>(dicMulty, "t1", "t2");
            Console.WriteLine("格式化后的SQL语句");
            Console.WriteLine(" {0}{1}", strSql, mapper.Condition);
            Console.WriteLine("格式化后的参数");
            foreach (var e in mapper.Paras)
            {
                Console.WriteLine("{0}:{1}      {2}", e.Key, e.Value, e.Value.GetType());
            }
            //如果想直接执行SQL语句，无需做类型映射
            dic.Clear();
            dic["t1.UserID"] = 1;
            dic["t1.Name"] = "xxx";
            dic["t1.BeginAge"] = 18;//Age>=18
            dic["t1.EndAge"] = 80;//Age<=80
            dic["t1.LikeName"] = "玲";//Name包含'玲'
            dic["t1.IsGirl"] = true;//IsGirl = true 
            dic["t1.BeginLoginTime"] = DateTime.Now.AddDays(-7);//LoginTime >= 七天前
            dic["t1.EndLoginTime"] = DateTime.Now.ToString();//LoginTime <= 今天
            dic["t2.LogID"] = 1;
            dic["t2.UserID"] = 1;
            dic["t2.LikeContent"] = "坏事";//Age>=18
            dic["t2.IsCreasy"] = false;//Age<=80
            dic["t2.CreateTime"] = DateTime.Parse("2013-11-05 10:52:37");
            mapper.Select(dic);
            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine("无需Mapper格式化后的条件");
            Console.WriteLine(mapper.Condition);
        }


    }

    public class User
    {
        public int UserID { get; set; }
        public string Name { get; set; }
        public int Age { get; set; }
        public bool IsGirl { get; set; }
        public DateTime LoginTime { get; set; }
    }

    public class Log
    {
        public int UserID { get; set; }
        public string Content { get; set; }
        public int LogID { get; set; }
        public DateTime CreateTime { get; set; }
        public bool IsCreasy { get; set; }
    }
}
